diff -ruN vdr-1.5.12/PLUGINS/src/pictures/Makefile vdr-1.5.13/PLUGINS/src/pictures/Makefile
--- vdr-1.5.12/PLUGINS/src/pictures/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/Makefile	2008-01-13 14:00:04.000000000 +0100
@@ -0,0 +1,110 @@
+#
+# Makefile for a Video Disk Recorder plugin
+#
+# $Id: Makefile 1.2 2008/01/13 13:00:04 kls Exp $
+
+# The official name of this plugin.
+# This name will be used in the '-P...' option of VDR to load the plugin.
+# By default the main source file also carries this name.
+# IMPORTANT: the presence of this macro is important for the Make.config
+# file. So it must be defined, even if it is not used here!
+#
+PLUGIN = pictures
+
+### The version number of this plugin (taken from the main source file):
+
+VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ print $$6 }' | sed -e 's/[";]//g')
+
+### The C++ compiler and options:
+
+CXX      ?= g++
+CXXFLAGS ?= -fPIC -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+
+### The directory environment:
+
+VDRDIR = ../../..
+LIBDIR = ../../lib
+TMPDIR = /tmp
+
+### Allow user defined options to overwrite defaults:
+
+-include $(VDRDIR)/Make.config
+
+### The version number of VDR's plugin API (taken from VDR's "config.h"):
+
+APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' $(VDRDIR)/config.h)
+
+### The name of the distribution archive:
+
+ARCHIVE = $(PLUGIN)-$(VERSION)
+PACKAGE = vdr-$(ARCHIVE)
+
+### Includes and Defines (add further entries here):
+
+INCLUDES += -I$(VDRDIR)/include
+
+DEFINES += -D_GNU_SOURCE -DPLUGIN_NAME_I18N='"$(PLUGIN)"'
+
+### The object files (add further files here):
+
+OBJS = $(PLUGIN).o entry.o menu.o player.o
+
+### The main target:
+
+all: libvdr-$(PLUGIN).so i18n
+
+### Implicit rules:
+
+%.o: %.c
+	$(CXX) $(CXXFLAGS) -c $(DEFINES) $(INCLUDES) $<
+
+### Dependencies:
+
+MAKEDEP = $(CXX) -MM -MG
+DEPFILE = .dependencies
+$(DEPFILE): Makefile
+	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
+
+-include $(DEPFILE)
+
+### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = $(VDRDIR)/locale
+I18Npo    = $(wildcard $(PODIR)/*.po)
+I18Nmsgs  = $(addprefix $(LOCALEDIR)/, $(addsuffix /LC_MESSAGES/vdr-$(PLUGIN).mo, $(notdir $(foreach file, $(I18Npo), $(basename $(file))))))
+I18Npot   = $(PODIR)/$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o $@ $<
+
+$(I18Npot): $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $^
+
+%.po: $(I18Npot)
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
+	@touch $@
+
+$(I18Nmsgs): $(LOCALEDIR)/%/LC_MESSAGES/vdr-$(PLUGIN).mo: $(PODIR)/%.mo
+	@mkdir -p $(dir $@)
+	cp $< $@
+
+.PHONY: i18n
+i18n: $(I18Nmsgs) $(I18Npot)
+
+### Targets:
+
+libvdr-$(PLUGIN).so: $(OBJS)
+	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
+	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
+
+dist: clean
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@mkdir $(TMPDIR)/$(ARCHIVE)
+	@cp -a * $(TMPDIR)/$(ARCHIVE)
+	@tar czf $(PACKAGE).tgz -C $(TMPDIR) $(ARCHIVE)
+	@-rm -rf $(TMPDIR)/$(ARCHIVE)
+	@echo Distribution package created as $(PACKAGE).tgz
+
+clean:
+	@-rm -f $(OBJS) $(DEPFILE) *.so *.tgz core* *~ $(PODIR)/*.mo $(PODIR)/*.pot
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/README vdr-1.5.13/PLUGINS/src/pictures/README
--- vdr-1.5.12/PLUGINS/src/pictures/README	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/README	2008-01-13 12:44:38.000000000 +0100
@@ -0,0 +1,119 @@
+This is a "plugin" for the Video Disk Recorder (VDR).
+
+Written by:                  Klaus Schmidinger <kls@cadsoft.de>
+
+Project's homepage:          www.cadsoft.de/vdr
+
+Latest version available at: www.cadsoft.de/vdr
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
+
+Description:
+============
+
+The 'pictures' plugin implements a simple picture viewer.
+
+There is already an 'image' plugin out there which has a lot more
+functionality than this one, but it's way too complex for my taste,
+and also converts the image files on-the-fly, which makes it slow
+on slow hardware.
+
+This plugin assumes that the pictures have already been converted to
+MPEG frames (with the 'pic2mpg' script that comes with this archive),
+and doesn't implement any fancy features like zooming, panning or
+tiled previews. It's just a very simple viewer.
+
+It also assumes a rather particular directory structure (see below),
+which I have found to fit well for my needs. If you use a different
+structure, the plugin should still work, but the information displayed
+in the caption may not be as expected.
+
+Remote control key functions while in the Pictures menu:
+========================================================
+
+- Left/right/Up/Down:  navigate in the menu as usual.
+- Ok:                  opens a directory or displays the selected
+                       picture.
+- Red/Play:            start a slide show at the first picture in the
+                       selected directory (or at the selected picture).
+
+Remote control key functions while displaying pictures:
+=======================================================
+
+- Left/Right:  advances to the previous/next picture. At the end of a directory
+               it automatically advances to the first picture of the next
+               directory and displays the caption.
+- Up/Play:     start the slide show.
+- Down/Pause:  stop the slide show.
+- Blue/Stop:   exit from the picture viewer.
+- Green/Prev:  skip to the first picture in the previous directory.
+- Yellow/Next: skip to the first picture in the next directory.
+- Ok:          toggle the caption display.
+- Back:        return to the picture selection menu.
+
+The slide show starts with the picture immediately following the one that
+is currently visible, and continues until the last available picture,
+automatically crossing directories as necessary.
+
+Pressing any of the Left/Right, Green/Prev, Yellow/Next or Back keys
+automatically stops an ongoing slide show.
+
+Directory structure:
+====================
+
+The 'pictures' plugin requires a particular directory structure in order to
+work properly. Starting at some base directory (e.g. "/path/to/pictures"),
+there is one directory level marking the year in which the pictures were
+taken, followed by a level with a properly sortable combination of month
+and description, and finally the plain picture files, as in
+
+/path/to/pictures/YEAR/MONTH_DESCRIPTION/*.jpg
+
+For example
+
+/path/to/pictures/2007/06a_Vacation_in_Colorado/dsc01234.jpg
+/path/to/pictures/2007/06a_Vacation_in_Colorado/dsc01235.jpg
+/path/to/pictures/2007/06b_Our_cat/dsc01236.jpg
+
+The MONTH is "01" for January through "12" for December. If there is more
+than one entry for one month, it should be followed by a letter to make them
+sort correctly. Note that this is just a suggestion on how to make the
+directories sort in the correct chronological order. Instead of the two digit
+month number, optionally followed by a letter, you can use anything else you
+like. There must be an underscore between the MONTH and the DESCRIPTION part,
+and any underscores within the DESCRIPTION will be converted to blanks when
+displaying the description (this is done so that blanks can be avoided in
+the directory names).
+
+Preparing the files:
+====================
+
+In order to display the pictures as "still pictures" on the DVB device, they
+need to be converted into MPEG frames. This procedure takes some time, and
+would make viewing pictures sluggish, especially on slow hardware. Therefore
+the script "pic2mpg" must be used to convert all picture files before
+using this plugin, as in
+
+pic2mpg /path/to/pictures /path/to/pictures.MPG
+
+This will recursively walk through all pictures in the source directory and
+convert them into MPEG frames, stored in the destination directory. The
+extension ".MPG" is just a suggestion, you can name the directory anything
+you like, and it doesn't have to start with the same path as the source
+directory. Just don't make the destination directory a subdirectory of
+the source directory, because this would surely lead to problems.
+See "pic2mpg -h" for a list of available options.
+The pic2mpg conversion can be run any time, even if converted pictures
+already exist. It will only convert pictures that haven't been converted
+yet. Any changes to the source directory will be reflected in the destination
+directory accordingly after pic2mpg has finished (note that this especially
+means that any files or directories in the destination tree that have no
+corresponding entry in the source tree will be deleted!). So you can run
+pic2mpg, for instance, after copying new pictures into your picture
+directory, or after making any other kind of changes to your existing
+pictures. It might even be a good idea to run pic2mpg in a (nightly)
+cron job.
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/entry.c vdr-1.5.13/PLUGINS/src/pictures/entry.c
--- vdr-1.5.12/PLUGINS/src/pictures/entry.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/entry.c	2008-01-06 10:52:41.000000000 +0100
@@ -0,0 +1,144 @@
+/*
+ * entry.c: Data structure to handle still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: entry.c 1.1 2008/01/06 09:52:41 kls Exp $
+ */
+
+#include "entry.h"
+
+cPictureEntry::cPictureEntry(const char *Name, const cPictureEntry *Parent, bool IsDirectory)
+{
+  name = strdup(Name);
+  parent = Parent;
+  isDirectory = IsDirectory;
+  entries = NULL;
+}
+
+cPictureEntry::~cPictureEntry()
+{
+  free(name);
+  delete entries;
+}
+
+int cPictureEntry::Compare(const cListObject &ListObject) const
+{
+  cPictureEntry *p = (cPictureEntry *)&ListObject;
+  if (IsDirectory() && !p->IsDirectory())
+     return -1;
+  if (!IsDirectory() && p->IsDirectory())
+     return +1;
+  if (IsDirectory())
+     return strcoll(name, p->name);
+  else
+     return strcmp(name, p->name); // correctly sorts dsc01234.jpg and dsc01234a.jpg in case pictures have been "squeezed in"
+}
+
+cString cPictureEntry::Path(void) const
+{
+  return parent ? AddDirectory(parent->Path(), name) : name;
+}
+
+void cPictureEntry::Load(void) const
+{
+  if (isDirectory && !entries) {
+     cString Directory = Path();
+     cReadDir d(Directory);
+     if (d.Ok()) {
+        struct dirent *e;
+        while ((e = d.Next()) != NULL) {
+              if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
+                 struct stat ds;
+                 if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
+                    if (!entries)
+                       entries = new cList<cPictureEntry>;
+                    entries->Add(new cPictureEntry(e->d_name, this, S_ISDIR(ds.st_mode)));
+                    }
+                 }
+              }
+        if (entries)
+           entries->Sort();
+        }
+     else
+        LOG_ERROR_STR(*Directory);
+     }
+}
+
+const cList<cPictureEntry> *cPictureEntry::Entries(void) const
+{
+  Load();
+  return entries;
+}
+
+const cPictureEntry *cPictureEntry::FirstPicture(void) const
+{
+  Load();
+  if (entries) {
+     for (cPictureEntry *pe = entries->First(); pe; pe = entries->Next(pe)) {
+         if (pe->IsDirectory()) {
+            const cPictureEntry *p = pe->FirstPicture();
+            if (p)
+               return p;
+            }
+         else
+            return pe;
+         }
+     }
+  return NULL;
+}
+
+const cPictureEntry *cPictureEntry::LastPicture(void) const
+{
+  Load();
+  if (entries) {
+     for (cPictureEntry *pe = entries->Last(); pe; pe = entries->Prev(pe)) {
+         if (pe->IsDirectory()) {
+            const cPictureEntry *p = pe->LastPicture();
+            if (p)
+               return p;
+            }
+         else
+            return pe;
+         }
+     }
+  return NULL;
+}
+
+const cPictureEntry *cPictureEntry::PrevPicture(const cPictureEntry *This) const
+{
+  if (This) {
+     const cPictureEntry *pe = (cPictureEntry *)entries->Prev(This);
+     if (pe) {
+        if (pe->IsDirectory()) {
+           const cPictureEntry *p = pe->LastPicture();
+           if (p)
+              return p;
+           return PrevPicture(pe);
+           }
+        return pe;
+        }
+     }
+  if (parent)
+     return parent->PrevPicture(this);
+  return NULL;
+}
+
+const cPictureEntry *cPictureEntry::NextPicture(const cPictureEntry *This) const
+{
+  if (This) {
+     cPictureEntry *pe = (cPictureEntry *)entries->Next(This);
+     if (pe) {
+        if (pe->IsDirectory()) {
+           const cPictureEntry *p = pe->FirstPicture();
+           if (p)
+              return p;
+           return NextPicture(pe);
+           }
+        return pe;
+        }
+     }
+  if (parent)
+     return parent->NextPicture(this);
+  return NULL;
+}
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/entry.h vdr-1.5.13/PLUGINS/src/pictures/entry.h
--- vdr-1.5.12/PLUGINS/src/pictures/entry.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/entry.h	2008-01-06 13:30:50.000000000 +0100
@@ -0,0 +1,36 @@
+/*
+ * entry.h: Data structure to handle still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: entry.h 1.1 2008/01/06 12:30:50 kls Exp $
+ */
+
+#ifndef _ENTRY_H
+#define _ENTRY_H
+
+#include <vdr/tools.h>
+
+class cPictureEntry : public cListObject {
+private:
+  char *name;
+  const cPictureEntry *parent;
+  bool isDirectory;
+  mutable cList<cPictureEntry> *entries;
+  void Load(void) const;
+public:
+  cPictureEntry(const char *Name, const cPictureEntry *Parent, bool IsDirectory);
+  virtual ~cPictureEntry();
+  virtual int Compare(const cListObject &ListObject) const;
+  const char *Name(void) const { return name; }
+  const cPictureEntry *Parent(void) const { return parent; }
+  bool IsDirectory(void) const { return isDirectory; }
+  cString Path(void) const;
+  const cList<cPictureEntry> *Entries(void) const;
+  const cPictureEntry *FirstPicture(void) const;
+  const cPictureEntry *LastPicture(void) const;
+  const cPictureEntry *PrevPicture(const cPictureEntry *This = NULL) const;
+  const cPictureEntry *NextPicture(const cPictureEntry *This = NULL) const;
+  };
+
+#endif //_ENTRY_H
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/menu.c vdr-1.5.13/PLUGINS/src/pictures/menu.c
--- vdr-1.5.12/PLUGINS/src/pictures/menu.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/menu.c	2008-01-13 12:35:18.000000000 +0100
@@ -0,0 +1,129 @@
+/*
+ * menu.c: A menu for still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: menu.c 1.1 2008/01/13 11:35:18 kls Exp $
+ */
+
+#include "menu.h"
+#include <vdr/tools.h>
+#include "entry.h"
+#include "player.h"
+
+char PictureDirectory[PATH_MAX] = "";
+
+static bool PathStartsWith(const char *Path, const char *Name)
+{
+  if (Path && Name) {
+     while (*Name) {
+           if (*Path++ != *Name++)
+              return false;
+           }
+     if (*Path && *Path != '/')
+        return false;
+     return true;
+     }
+  return false;
+}
+
+static const char *NextLevel(const char *Path)
+{
+  if (Path) {
+     const char *p = strchr(Path, '/');
+     return p ? p + 1 : NULL;
+     }
+  return Path;
+}
+
+cPictureEntry *cPictureMenu::pictures = NULL;
+
+cPictureMenu::cPictureMenu(const cPictureEntry *PictureEntry, const char *Path)
+:cOsdMenu(tr("Pictures"))
+{
+  pictureEntry = PictureEntry;
+  if (!pictureEntry)
+     pictureEntry = pictures = new cPictureEntry(PictureDirectory, NULL, true);
+  if (pictureEntry->Parent()) {
+     if (!pictureEntry->Parent()->Parent())
+        SetTitle(pictureEntry->Name()); // Year
+     else
+        SetTitle(cString::sprintf("%s: %s", pictureEntry->Parent()->Name(), *HandleUnderscores(pictureEntry->Name()))); // Year/Description
+     }
+  Set(Path);
+}
+
+cPictureMenu::~cPictureMenu()
+{
+  if (pictures && pictureEntry && !pictureEntry->Parent())
+     DELETENULL(pictures);
+}
+
+void cPictureMenu::Set(const char *Path)
+{
+  Clear();
+  const cList<cPictureEntry> *l = pictureEntry->Entries();
+  if (l) {
+     for (const cPictureEntry *e = l->First(); e; e = l->Next(e)) {
+         cString Name = HandleUnderscores(e->Name());
+         if (!e->IsDirectory())
+            Name.Truncate(-4); // don't display the ".mpg" extension
+         Add(new cOsdItem(HandleUnderscores(Name)), PathStartsWith(Path, e->Name()));
+         }
+     }
+  SetHelp(Count() ? trVDR("Button$Play") : NULL, NULL, NULL, cPictureControl::Active() ? trVDR("Button$Stop") : NULL);
+  if (Current() >= 0) {
+     const char *p = NextLevel(Path);
+     if (p)
+        SelectItem(p);
+     }
+}
+
+eOSState cPictureMenu::SelectItem(const char *Path, bool SlideShow)
+{
+  cOsdItem *Item = Get(Current());
+  if (Item) {
+     const cList<cPictureEntry> *l = pictureEntry->Entries();
+     if (l) {
+        cPictureEntry *pe = l->Get(Current());
+        if (pe) {
+           if (SlideShow) {
+              cControl::Launch(new cPictureControl(pictures, pe, true));
+              pictures = NULL; // cPictureControl takes ownership
+              return osEnd;
+              }
+           if (pe->IsDirectory())
+              return AddSubMenu(new cPictureMenu(pe, Path));
+           else if (!Path) {
+              cControl::Launch(new cPictureControl(pictures, pe));
+              pictures = NULL; // cPictureControl takes ownership
+              return osEnd;
+              }
+           }
+        }
+     }
+  return osContinue;
+}
+
+eOSState cPictureMenu::ProcessKey(eKeys Key)
+{
+  eOSState state = cOsdMenu::ProcessKey(Key);
+  if (state == osUnknown) {
+     switch (Key) {
+       case kRed:
+       case kPlay:   return SelectItem(NULL, true);
+       case kBlue:
+       case kStop:   if (cPictureControl::Active())
+                        return osStopReplay;
+                     break;
+       case kOk:     return SelectItem();
+       default:      break;
+       }
+     }
+  return state;
+}
+
+cPictureMenu *cPictureMenu::CreatePictureMenu(void)
+{
+  return new cPictureMenu(NULL, cPictureControl::LastDisplayed());
+}
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/menu.h vdr-1.5.13/PLUGINS/src/pictures/menu.h
--- vdr-1.5.12/PLUGINS/src/pictures/menu.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/menu.h	2008-01-12 12:22:52.000000000 +0100
@@ -0,0 +1,31 @@
+/*
+ * menu.h: A menu for still pictures
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: menu.h 1.1 2008/01/12 11:22:52 kls Exp $
+ */
+
+#ifndef _MENU_H
+#define _MENU_H
+
+#include <vdr/osdbase.h>
+#include <vdr/tools.h>
+#include "entry.h"
+
+extern char PictureDirectory[PATH_MAX];
+
+class cPictureMenu : public cOsdMenu {
+private:
+  static cPictureEntry *pictures;
+  const cPictureEntry *pictureEntry;
+  void Set(const char *Path);
+  eOSState SelectItem(const char *Path = NULL, bool SlideShow = false);
+public:
+  cPictureMenu(const cPictureEntry *PictureEntry, const char *Path = NULL);
+  ~cPictureMenu();
+  virtual eOSState ProcessKey(eKeys Key);
+  static cPictureMenu *CreatePictureMenu(void);
+  };
+
+#endif //_MENU_H
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/pic2mpg vdr-1.5.13/PLUGINS/src/pictures/pic2mpg
--- vdr-1.5.12/PLUGINS/src/pictures/pic2mpg	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/pic2mpg	2008-01-13 12:09:12.000000000 +0100
@@ -0,0 +1,176 @@
+#!/usr/bin/perl
+
+# pic2mpg: Convert picture files to MPEG still frames
+#
+# Converts either a single picture file or all files in a
+# given directory (recursively) to MPEG still frames.
+#
+# See the README file for copyright information and how to reach the author.
+#
+# $Id: pic2mpg 1.1 2008/01/13 11:09:12 kls Exp $
+
+## TODO implement HDTV (1920 x 1080)
+
+use File::Path;
+use Getopt::Std;
+use Image::Size;
+
+$Usage = qq{
+Usage: $0 [options] picture-dir mpeg-dir
+       $0 [options] picture-file mpeg-file
+
+Options: -a             Aspect ratio 4:3 (default is 16:9)
+         -h             print Help
+         -f             Force conversion
+         -n             NTSC (default is PAL)
+         -v num         Verbose (0=none, 1=list files, 2=detailed)
+         -x percent     X overscan in percent
+         -y percent     Y overscan in percent
+};
+
+getopts("ahfnv:x:y:") || die $Usage;
+
+die $Usage if $opt_h;
+
+$Aspect    = $opt_a;
+$Force     = $opt_f;
+$NTSC      = $opt_n;
+$Verbose   = $opt_v;
+$OverscanX = $opt_x;
+$OverscanY = $opt_y;
+
+$ListFiles = $Verbose >= 1;
+$Detailed  = $Verbose >= 2;
+
+# Screen size:
+
+$SW = $NTSC ? 720 : 720;
+$SH = $NTSC ? 480 : 576;
+
+$ScreenRatio = $Aspect ? 4 / 3 : 16 / 9;
+
+# Converter programs:
+
+%PNMCONV = (
+  bmp  => "bmptopnm",
+  gif  => "giftopnm",
+  jpeg => "jpegtopnm",
+  jpg  => "jpegtopnm",
+  png  => "pngtopnm",
+  pnm  => "cat",
+  tif  => "tifftopnm",
+  tiff => "tifftopnm",
+  );
+
+# Command options:
+
+die "$0: missing parameter\n" unless $ARGV[0] && $ARGV[1];
+die "$0: file or directory not found: $ARGV[0]\n" unless -e $ARGV[0];
+die "$0: source and destination must be different\n" if $ARGV[0] eq $ARGV[1];
+
+$verbose1  = $Detailed ? "--verbose" : "";
+$verbose2  = $Detailed ? "-v 2" : "-v 0";
+$system1   = $NTSC ? "" : "--pal";
+$system2   = $NTSC ? "n" : "p";
+$framerate = $NTSC ? "30000:1001" : "25:1";
+$aspect    = $Aspect ? "2" : "3";
+
+# Convert a single file:
+
+if (-f $ARGV[0]) {
+   die "$0: mixed file and directory ('$ARGV[0]' <-> '$ARGV[1]')\n" unless !-e $ARGV[1] || -f $ARGV[1];
+   ConvertFile($ARGV[0], $ARGV[1]);
+   exit;
+   }
+
+die "$0: mixed directory and file ('$ARGV[0]' <-> '$ARGV[1]')\n" unless !-e $ARGV[1] || -d $ARGV[1];
+
+$PICDIR = $ARGV[0];
+$MPGDIR = $ARGV[1];
+
+# Convert pictures to mpegs:
+
+chdir($PICDIR) || die "$PICDIR: $!\n";
+
+@Pictures = `find -type f`;
+chomp(@Pictures);
+
+for $pic (@Pictures) {
+    my $mpg = "$MPGDIR/$pic.mpg";
+    if ($Force || !-e $mpg || -M $mpg > -M $pic) {
+       (my $dir = $mpg) =~ s/\/[^\/]*$//;
+       mkpath($dir);
+       ConvertFile($pic, $mpg);
+       }
+    }
+
+# Remove mpegs without pictures:
+
+chdir($MPGDIR) || die "$MPGDIR: $!\n";
+
+@Mpegs = `find -type f`;
+chomp(@Mpegs);
+
+for $mpg (@Mpegs) {
+    my $pic = "$PICDIR/$mpg";
+    $pic =~ s/\.mpg$//;
+    if (!-e $pic) {
+       print "removing $mpg\n";
+       unlink($mpg);
+       }
+    }
+
+# Remove empty directories:
+
+chdir($MPGDIR) || die "$MPGDIR: $!\n";
+
+for ($i = 0; $i < 10; $i++) { # dirs might become empty when removing empty subdirs
+    @Dirs = `find -type d -empty`;
+    chomp(@Dirs);
+    last unless @Dirs;
+
+    for $dir (@Dirs) {
+        $dir = EscapeMeta($dir);
+        print "removing $dir\n";
+        !system("rm -rf $dir") || die "$dir: $!\n";
+        }
+    }
+
+# Actual file conversion:
+
+sub ConvertFile
+{
+  my ($Pict, $Mpeg) = @_;
+  (my $Type) = $Pict =~ /\.([^\.]*)$/;
+  die "unknown file type '$Type': '$Pict'\n" unless defined $PNMCONV{$Type};
+  my ($w, $h) = imgsize($Pict);
+  print "image size is $w x $h\n" if ($Detailed);
+  if ($w / $h <= $ScreenRatio) {
+     $w = $h * $ScreenRatio;
+     }
+  else {
+     $h = $w / $ScreenRatio;
+     }
+  my $ScaleW = $SW / $w * (100 - 2 * $OverscanX) / 100;
+  my $ScaleH = $SH / $h * (100 - 2 * $OverscanY) / 100;
+  $Pict = EscapeMeta($Pict);
+  $Mpeg = EscapeMeta($Mpeg);
+  print "$Pict -> $Mpeg\n" if $ListFiles;
+  my $Cmd = "$PNMCONV{$Type} $Pict 2> /dev/null |"
+          . "pnmscale $verbose1 --xscale=$ScaleW --yscale=$ScaleH |"
+          . "pnmpad $verbose1 --black --width $SW --height $SH |"
+          . "ppmntsc $verbose1 $system1 |"
+          . "ppmtoy4m $verbose2 -F $framerate -I p -S 420mpeg2 |"
+          . "mpeg2enc $verbose2 -f 3 -b 12500 -a $aspect -q 1 -n $system2 -o $Mpeg";
+  !system($Cmd) || die "$Cmd: $!\n";
+  $Cmd = "touch -r $Pict $Mpeg";
+  !system($Cmd) || die "$Cmd: $!\n";
+}
+
+sub EscapeMeta
+{
+  my $META = ' !"#$%&\'()*;<>?[\\]`{|}~';
+  my $s = shift;
+  $s =~ s/([$META])/\\$1/g;
+  return $s;
+}
diff -ruN vdr-1.5.12/PLUGINS/src/pictures/pictures.c vdr-1.5.13/PLUGINS/src/pictures/pictures.c
--- vdr-1.5.12/PLUGINS/src/pictures/pictures.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.13/PLUGINS/src/pictures/pictures.c	2008-01-12 15:46:52.000000000 +0100
@@ -0,0 +1,124 @@
+/*
+ * pictures.c: A plugin for the Video Disk Recorder
+ *
+ * See the README file for copyright information and how to reach the author.
+ *
+ * $Id: pictures.c 1.1 2008/01/12 14:46:52 kls Exp $
+ */
+
+#include <getopt.h>
+#include <vdr/plugin.h>
+#include "menu.h"
+#include "player.h"
+
+static const char *VERSION       = "0.0.1";
+static const char *DESCRIPTION   = trNOOP("A simple picture viewer");
+static const char *MAINMENUENTRY = trNOOP("Pictures");
+
+// --- cMenuSetupPictures ----------------------------------------------------
+
+class cMenuSetupPictures : public cMenuSetupPage {
+private:
+  char newPictureDirectory[PATH_MAX];
+  int newSlideShowDelay;
+protected:
+  virtual void Store(void);
+public:
+  cMenuSetupPictures(void);
+  };
+
+cMenuSetupPictures::cMenuSetupPictures(void)
+{
+  strn0cpy(newPictureDirectory, PictureDirectory, sizeof(newPictureDirectory));
+  newSlideShowDelay = SlideShowDelay;
+  Add(new cMenuEditStrItem(tr("Picture directory"),    newPictureDirectory, sizeof(newPictureDirectory)));
+  Add(new cMenuEditIntItem(tr("Slide show delay (s)"), &newSlideShowDelay));
+}
+
+void cMenuSetupPictures::Store(void)
+{
+  SetupStore("PictureDirectory", strn0cpy(PictureDirectory, newPictureDirectory, sizeof(PictureDirectory)));
+  SetupStore("SlideShowDelay",   SlideShowDelay = newSlideShowDelay);
+}
+
+// --- cPluginPictures -------------------------------------------------------
+
+class cPluginPictures : public cPlugin {
+private:
+  // Add any member variables or functions you may need here.
+public:
+  cPluginPictures(void);
+  virtual ~cPluginPictures();
+  virtual const char *Version(void) { return VERSION; }
+  virtual const char *Description(void) { return tr(DESCRIPTION); }
+  virtual const char *CommandLineHelp(void);
+  virtual bool ProcessArgs(int argc, char *argv[]);
+  virtual const char *MainMenuEntry(void) { return tr(MAINMENUENTRY); }
+  virtual cOsdObject *MainMenuAction(void);
+  virtual cMenuSetupPage *SetupMenu(void);
+  virtual bool SetupParse(const char *Name, const char *Value);
+  };
+
+cPluginPictures::cPluginPictures(void)
+{
+  // Initialize any member variables here.
+  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
+  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
+}
+
+cPluginPictures::~cPluginPictures()
+{
+  // Clean up after yourself!
+}
+
+const char *cPluginPictures::CommandLineHelp(void)
+{
+  // Return a string that describes all known command line options.
+  return "  -d DIR,   --dir=DIR      set the picture directory to DIR\n";
+}
+
+bool cPluginPictures::ProcessArgs(int argc, char *argv[])
+{
+  // Implement command line argument processing here if applicable.
+  static struct option long_options[] = {
+       { "dir",      required_argument, NULL, 'd' },
+       { NULL }
+     };
+
+  int c;
+  while ((c = getopt_long(argc, argv, "d:s:", long_options, NULL)) != -1) {
+        switch (c) {
+          case 'd': strn0cpy(PictureDirectory, optarg, sizeof(PictureDirectory));
+                    break;
+          default:  return false;
+          }
+        }
+  return true;
+}
+
+cOsdObject *cPluginPictures::MainMenuAction(void)
+{
+  // Perform the action when selected from the main VDR menu.
+  if (*PictureDirectory)
+     return cPictureMenu::CreatePictureMenu();
+  Skins.Message(mtWarning, tr("No picture directory has been defined!"));
+  return NULL;
+}
+
+cMenuSetupPage *cPluginPictures::SetupMenu(void)
+{
+  // Return a setup menu in case the plugin supports one.
+  return new cMenuSetupPictures;
+}
+
+bool cPluginPictures::SetupParse(const char *Name, const char *Value)
+{
+  // Parse your own setup parameters and store their values.
+  if      (!strcasecmp(Name, "PictureDirectory")) strn0cpy(PictureDirectory, Value, sizeof(PictureDirectory));
+  else if (!strcasecmp(Name, "SlideShowDelay"))   SlideShowDelay = atoi(Value);
+  else
+     return false;
+  return true;
+}
+
+VDRPLUGINCREATOR(cPluginPictures); // Don't touch this!
